require("../css/index.less");
const $ = require('jquery');
require('jquery-templates');
const md5 = require('js-md5');
require("./modal.js")
const {api,post,pageMap,delCookie,setCookie,getCookie} = require('./utils.js');
let userInfo={};
$(function(){
  getMenu();
  //菜单展开收起
  sureChangeWord()
  $(".main").css({
    height:$(window).height()-70+'px'
  })
  $("body").on('focus',".modalAction input",function(){
    $(this).attr("type","password")
  })
  $(window).click(function(e){
    $(".userAction").css("display","none")
  })
  $("#changeWord").css("opacity",hasData('FUNC000002')?'1':'0.5').hover(function(){
    $(this).css("color","#777777")
  })
});
//判断有无某一权限
function hasData(data){
  let lis = JSON.parse(getCookie("codeLis"))
  if(lis.indexOf(data)>-1){//有权限
      return true
  }
  return false;
}
function userActionHide(e){
  $(".userAction").css("display","none")
}
window.userActionHide = userActionHide

function initMenu(data,userInfo){
  //菜单数据填充
  $("#menuTmpl").tmpl(data).appendTo(".menu ul");
  //用户数据填充
  $("#userName").text(userInfo.linkman);
  //菜单收起展开
  $(".menu .page").eq(0).addClass("active")
  $(".list-1").on("click",function(){
    // $(".list-1 .slide-up").removeClass('slide-up');
    // $(this).toggleClass('slide-up');
    const ulShow =  $(this).find("ul").css("display")
    if(ulShow == "none"){
      $(this).removeClass("list-1-show")
      $(this).addClass("list-1-show")
    }else{
      $(this).removeClass("list-1-show")
    }
    $(this).find("ul").slideToggle();
    
  });
  $(".list-1 li").on("click",function(e){
    e.stopPropagation();
  });
  //右侧页面切换
  $(".page").on("click",function(){
    $(".menu .active").removeClass('active');
    $(this).addClass("active");
    const code = $(this).attr("code");
    let url = './'+pageMap[code];
    if(code === 'YH-BLZK-ZKPFGR'){
      url += `?doctorName=${userInfo.linkman}`
    }
    $("#contentIframe").attr("src",url);
  });
}
function getMenu(){
  post(api.getMenu).then(function(res){
    if(res.data.code==='0'){
      const data = res.data.data;
      initMenu(data.menuWrappers,data.userLoginDTO);
      userInfo = data.userLoginDTO
      setCookie("hospital",data.basHospitalInfoDTO.name)
      getAllCode(data.menuWrappers);
      hasData("FUNC000002")?"":$("#changeWord").hide();   //修改密码无权限不显示
    }
  });
};
function getAllCode(data){
  let lis = [],personCodeLis=[],deptCodeLis=[],trdObj={}
  for(let i = 0;i < data.length;i++){
    let tmpSon = data[i]
    lis.push(tmpSon.code)
    if(tmpSon.subMenuList.length > 0){//三层
      for(let j = 0;j<tmpSon.subMenuList.length;j++){//第二层循环
        let tmpGrandSon = tmpSon.subMenuList[j]
        let sonLis=[]
        lis.push(tmpGrandSon.code)
        for(let m = 0;m < tmpGrandSon.sysUserPermissionDTOList.length;m++){
          let tmpData = tmpGrandSon.sysUserPermissionDTOList[m]
          lis.push(tmpData.code)
          sonLis.push(tmpData.code)
        }
        trdObj[tmpGrandSon.code] = sonLis
      }
    }else{//两层
      for(let n = 0;n < tmpSon.sysUserPermissionDTOList.length;n++){
        let tmpData = tmpSon.sysUserPermissionDTOList[n]
        lis.push(tmpData.code)
      }
    }
  }
  setCookie("codeLis",JSON.stringify(lis))
  setCookie("trdObj",JSON.stringify(trdObj))
}
function sureChangeWord(){
  $(document).on('click','.sureChange',function(){
    let oldword = $(".oldword").val().trim()
    let newword = $(".newword").val().trim()
    let sureword = $(".sureword").val().trim()
    if(!oldword){
      $(".modalAction .waring i").html('请输入原密码')
      return
    }else if(!newword){
      $(".modalAction .waring i").html('请输入新密码')
      return
    }else if(!sureword){
      $(".modalAction .waring i").html('请确认新密码')
      return
    }else if(newword != sureword){
      $(".modalAction .waring i").html('两次密码不一致')
      return
    }
    $(".modalAction .waring i").html('')
    changeWord(oldword,newword)
  })
}
function changeWord(oldword,newword){
  post(api.midifyPassword,{
    "modifyPassword": md5(newword),
    "password": md5(oldword)
  }).then(function(res){
    const data = res.data;
    if(data.code==='0'){
      window.location.href = './login.html'
    }else{
      $(".oldWaring").html(data.msg)
      return
    }
  });
}
//用户信息下拉事件
$(".login").click(function(e){
  e.stopPropagation()
  $(".userAction").slideToggle();
})
//点击修改密码
$("#changeWord").click(function(e){
  if(!hasData('FUNC000002')){
      return
  }
  e.stopPropagation()
  const status = $(".modalAction").css("display")
  $.alerModal({
    title:"修改密码",
    type:"modal",
    width:'450',
    time:'1000',
    sureText:'保存',
    message:`
    <div class="modalAction">
      <p><span>原密码：</span><input type="text" placeholder="请输入原密码" class="oldword" autocomplete="off"><i class="oldWaring"></i></p>
      <p><span>新密码：</span><input type="text" placeholder="请输入新密码" class="newword" autocomplete="off"></p>
      <p><span>确认新密码：</span><input type="text" placeholder="请输入新密码" class="sureword" autocomplete="off"></p>
      <p class="waring"><span></span><i></i></p>
    </div>
  `});
  $(".userAction").hide();
})
//推出登录
$(".login-out").click(function(){
  delCookie('accessToken')
})
