require("../css/qcScore.less");
const $ = require('jquery');
require('jquery-templates');
require('./modal.js');
const {api,post,getUrlArgObject,setBoxHeight,getCookie} = require('./utils.js');
const {keyMaps} = require('./maps.js');
const {wardRound,preoperation,summary,operationRecord,applicationForm,resultForm,consultationNote,difficultRecord,illnessNotice,pathologicTest,rescueRecord,transfusionEvaluate,transfusionRecord} = require("./qcScore_byll.js")
//本页全局变量
let global_flawData = {};    //缺陷数据
const global_id=getUrlArgObject("id");
const global_age = getUrlArgObject("age");
const global_code = getUrlArgObject("code");
let global_activeTab=$(".sub-menu .page.active").attr("code");  //当前激活菜单项
let global_modules ={};   //模板数据缓存

$(function(){
  //getSubMenu();
  //initScoreItem();
  //getRecordDetail();
  getAllModules()
  //getInfoModule(15);    //根据对应id获取模板
function initMenu(data){
  const menu=[{id:0,name:"缺陷总览",parentId: -1,sonMode: []},...(data||[])];
  //菜单数据填充
  $("#subMenuTmpl").tmpl(menu).appendTo("#subMenu");
  //菜单收起展开
  $(".list-1").on("click",function(){
    $(".list-1 .slide-up").removeClass('slide-up');
    $(this).toggleClass('slide-up');
    $(this).find("ul").slideToggle();
  });
  $(".list-1 li").on("click",function(e){
    e.stopPropagation();
  });
  //右侧内容切换
  $(".page").on("click",function(){
    if($(this).attr("code")==="缺陷总览"){
      $(".flaw-table").show();
    }else{
      $(".flaw-table").hide();
    }

    //选中样式
    $(".sub-menu .active").removeClass('active');
    $(this).addClass("active");
    //显示对应内容
    const code=$(this).attr("code");
    global_activeTab=code;
    //initModuleData();
    $(".content-item,.flaw-item").hide();
    $(".content-item[code='"+code+"']").show();
    showFlawList();
  });
}
//判断有无某一权限
function hasData(data){
  let trdObj = JSON.parse(getCookie("trdObj"))
  let lis = trdObj[global_code]
  if(!lis){
    return false
  }
  if(lis.indexOf(data)>-1){//有权限
      return true
  }
  return false;
}
//获取病例明细
function getRecordDetail(){
  post(api.getRecordDetail,{'behospitalCode':global_id}).then(function(res){
    if(res.data.code==='0'){
      const data = res.data.data;
   
      const {beHospital,result,msg} = data;
      const info=Object.assign(beHospital,result);
      initMenu(JSON.parse(result.menuData));
      $(".sub-menu>ul>li:first-child.page").addClass("active");
     global_activeTab=$(".sub-menu .page.active").attr("code");
      initPatientInfo(info);
      initContent(result.pageData);
      initList(msg);
      initScoreItem(msg);
      global_flawData=msg;
      /*let obj = JSON.parse(result.pageData)
      
      infoNotNull(obj,'查房记录')&&wardRound(obj['查房记录'],'查房记录')
      infoNotNull(obj,'术前讨论、术前小结')&&preoperation(obj['术前讨论、术前小结'],'术前讨论、术前小结')
      infoNotNull(obj,'阶段小结')&&summary(obj['阶段小结'],'阶段小结')
      infoNotNull(obj,'手术记录')&&operationRecord(obj['手术记录'],'手术记录')
      infoNotNull(obj,'会诊申请单')&&applicationForm(obj['会诊申请单'],'会诊申请单')
      infoNotNull(obj,'会诊结果单')&&resultForm(obj['会诊结果单'],'会诊结果单')
      infoNotNull(obj,'会诊记录')&&consultationNote(obj['会诊记录'],'会诊记录')
      infoNotNull(obj,'疑难病例讨论记录')&&difficultRecord(obj['疑难病例讨论记录'],'疑难病例讨论记录')
      infoNotNull(obj,'病危通知书')&&illnessNotice(obj['病危通知书'],'病危通知书')
      infoNotNull(obj,'病理检验送检单')&&pathologicTest(obj['病理检验送检单'],'病理检验送检单')
      infoNotNull(obj,'抢救记录')&&rescueRecord(obj['抢救记录'],'抢救记录')
      infoNotNull(obj,'输血后效果评价')&&transfusionEvaluate(obj['输血后效果评价'],'输血后效果评价')*/
      setBoxHeight();
    }
  });
}
//判断模块内容是否不为空
function infoNotNull(obj,moduleName){
  if( obj[moduleName]&&obj[moduleName].length > 0 &&Object.keys(obj[moduleName][0]).length !== 0 ){
    return true
  }
  return false
}
//填充患者信息
function initPatientInfo(data){
  const obj=Object.assign({},data,{age:!global_age||global_age=="null"?"-":global_age});
  $("#infoTmpl").tmpl(obj).appendTo("#patientInfo");
}
//显示病例模块明细
function initContent(data){
  const obj = JSON.parse(data);
  let info=[];
  let hml='',moduleId='';
  for(let k in obj){
    if(k==="病案首页"){   //病案首页不使用动态模板
      info=formatInfoData(k,obj[k][0]);
      $("#indexTmpl").tmpl(info).appendTo("#contentInfo");
      continue;
    }
    for(let i in obj[k]){
      info=formatInfoData(k,obj[k][i]);
      moduleId=info.mode_id;
      if(global_modules[moduleId]){
        hml=initModuleData(moduleId,obj[k].length);
        $.tmpl(hml,info).appendTo("#contentInfo");
      };
    }
  }
  if(obj["病案首页"]&&obj["病案首页"][0]["出院诊断"]){
    const diag = JSON.parse(obj["病案首页"][0]["出院诊断"]);
    $("#tableTmpl").tmpl({k:"出院诊断",data:diag}).appendTo("#diagTable");
  }
  if(obj["病案首页"]&&obj["病案首页"][0]["手术信息"]){
    const diag = JSON.parse(obj["病案首页"][0]["手术信息"]);
    $("#tableTmpl").tmpl({k:"手术信息",data:diag}).appendTo("#surgeryTable");
  }
  $(".content-item[code="+global_activeTab+"]").show();
  //console.log(obj)
}

function formatInfoData(k,data){
  let obj = {},name="";
  for(let i in data){
    if(i!=="mode_id"){
      name=i.replace(/[^\u4e00-\u9fa5|a-zA-Z0-9]+/g,"").replace(/^[0-9]+/,"a");    //过滤key中存在的特殊符号，模板会渲染不出来且不报错
      obj[name]=data[i].replace(/\n/g,"<br/>")||"";
    }else{
      obj[i]=data[i].replace(/\n/g,"<br/>")||"";
    }
  }
  return Object.assign({title:k},obj);
}

/*function formatData(data,title){
  if(!keyMaps[title]){
    return data;
  }
  const keyArr=Object.keys(keyMaps[title]);
  let obj={};
  keyArr.map((k)=>{
    obj[keyMaps[title][k]]=data[0][k]||"";
  });
  const obj1=Object.assign({},obj,data[0]);
  return [obj1];
}*/

function initList(data){
  $("#flawTotalList").tmpl({data:data}).appendTo(".flaw-table");
  $(".slide-up").off("click").on("click",function(){
    const name = $(this).text();
    $("tr[code='"+name+"']").slideToggle();
    $(this).toggleClass("down");
  });
}

//评分项数据填充
function initScoreItem(data){
  $("#flaws .flaw-box").html("");
  let hasAu = hasData('FUNC000013')
  let hasAu2 = hasData('FUNC000012')
  for(let k in data){
    $("#flawTmpl").tmpl(data[k]).appendTo("#flaws .flaw-box");
  }
  showFlawList();
  $(".flaw-item .oper a").click(function () {
    const i = $(".flaw-item[code="+global_activeTab+"]").index($(this).parents(".flaw-item"));
    const code=$(this).attr("code");
    const isEdit = $(this).is(".edit-flaw");
    if(!hasAu)return
    if(isEdit&&hasAu){
      showModal('0',code,i);
    }else if(!isEdit&&hasAu2){
      showModal('1',code,i);
    }
  })
  $(".edit-flaw").css("opacity",hasAu?"1":"0.5")
  $(".del-flaw").css("opacity",hasAu2?"1":"0.5")
  $(".flaw-item .title a[href]").click(function(){
    const id = $(this).attr("href");
    $(".info-item .cont,.flaw-item .title").removeClass("active");
    $(id).addClass("active");
    $(this).parent().addClass("active");
  });
}

//显示缺陷列表
function showFlawList(){
  const hml = $(".flaw-item[code="+global_activeTab+"]");
  if(hml.length){
    hml.show();
    $("#flaws .empty").hide();
  }else{
    $("#flaws .empty").length?$("#flaws .empty").show():$("#emptyTmpl").tmpl().appendTo("#flaws .flaw-box");
  }
}

//删除评分项
function delScore(id){
  const param={
    'behospitalCode':global_id,
    'optResultAlgVO':{
      'id':id
    }
  };
  post(api.delScore,param).then(function(res){
    if(res.data.code==='0'){
      $("#delModal").hide();
      updateFlaws(res.data.data);
      $.alerModal({"message":"删除成功",type:"tip",time:'1000'});
    }
  });
}
//修改评分项
function editScore(info){
  const param={
    "behospitalCode": global_id,
    "optResultAlgVO": info
};
  post(api.editScore,param).then(function(res){
    if(res.data.code==='0'){
      $("#delModal").hide();
      updateFlaws(res.data.data);
      $.alerModal({"message":"修改成功",type:"tip",time:'1000'});
    }
  });
}
//显示删除/修改弹窗
function showModal(flag,code,i){
  $("#delModal .modal-body").html("");
  $("#delModal").show();
  //事件解绑
  $("#delModal .confirm").off("click");
  $("#qcScore,#qcMsg").off("input");
  const flawsList = formatFlawKeys(global_flawData);
  const info = flawsList[global_activeTab][i];
  if(flag==='0'){   //修改
    $("#delModal .title").text("修改");
    $("#delModal .confirm").text("保存");
    $("#editTmpl").tmpl(info).appendTo("#delModal .modal-body");
    //分数输入验证
    $("#qcScore").on("input",function(){
      const val=$(this).val();
      if(/^[0-9]\d*$|^[0-9]\d*(.\d)?$/.test(val)){
        $(".edit-box .warning").hide();
      }else{
        $(".edit-box .warning .red").text("支持≥0的数字输入，最多保留小数点后1位~");
        $(".edit-box .warning").show();
      }
    });
    //提示信息输入验证
    $("#qcMsg").on("input",function(){
      const val=$(this).val();
      if(val.trim()){
        $(".edit-box .warning").hide();
      }else{
        $(".edit-box .warning .red").text("提示信息不能为空~");
        $(".edit-box .warning").show();
      }
    });
    $("#delModal .confirm").click(function(){
      if($(".edit-box .warning").is(":visible")){
        return;
      }
      const obj = Object.assign({},info,{msg:$("#delModal #qcMsg").val(),score:$("#delModal #qcScore").val()});
      editScore(obj);
    });
  }else{
    $("#delModal .title").text("删除评分");
    $("#delModal .confirm").text("确定");
    $("#delModal .modal-body").html('<p>确定要删除该评分记录吗？</p>');
    $("#delModal .confirm").click(function(){
      delScore(code,info);
    });
  }
}
//缺陷列表key值去掉特殊符号
function formatFlawKeys(data){
    const obj = {};
    for(let k in data){
      obj[k.replace(/[^\u4e00-\u9fa5|a-zA-Z0-9]+/g,'')]=data[k];
    }
    return obj;
  }

//更新缺陷列表
  function updateFlaws(info){
  $("#patientInfo .level").text("质控等级："+info.level);
  $("#patientInfo .score").text("质控得分："+info.scoreRes);
  const param = {
    'behospitalCode':global_id,
    'paramStr':[
      "msg"
    ]
  };
    post(api.getRecordDetail,param).then(function(res){
      if(res.data.code==='0'){
        const data = res.data.data;
        const {msg} = data;
        initScoreItem(msg);
        global_flawData=msg;
      }
    });
  }

//获取病例模板
  function getInfoModule(moduleId){
    const param = {
      moduleId:moduleId
    };
    post(api.getInfoModule,param).then(function(res){
      if(res.data.code==='0'){
        const data = res.data.data;
        cachemoduleDatas(data);
        getRecordDetail();
      }
    });
  }

  //模板数据缓存
  function cachemoduleDatas(data){
    const moudle=data.moduleDetail;
    global_modules[data.modeName]=[];
    for(let i in moudle){
      global_modules[data.modeName].push(moudle[i]);
    }
  }

//初始化模板
  function initModuleData(mid,n){
    const module=global_modules[mid].moduleDetail;
    const key = global_modules[mid].modeName.replace(/[^\u4e00-\u9fa5|a-zA-Z0-9]+/g,'');
    let hml = '<div class="content-item" code="'+key+'">' +
      '<h2 class="title">'+key+'</h2>' +
      (n>1?'<div class="container">':'<div class="container content-ht">');

    for(let i in module){
      hml=hml+'<div class="info-item">';
      for(let j=0;j<module[i].length;j++) {
        const detal = module[i][j].questionDTO;
        const {tagType} = detal;
        switch (tagType) {
          case 1:
            hml = hml + simpleStructure(detal);
            break;
          case 4:
            hml = hml + combineStructure(detal);
            break;
          default:
            break;
        }
      }
      hml = hml+"</div>"
    }
    return hml+"</div></div>";
  }

  //基础类型结构生成
  function simpleStructure(data){
    const {name, val,monoLine,addLine,position,bold,retract,id} = data;
    const posClass = position===1?'text-left':'';
    const boldClass = bold===1?'text-bold':'';
    const retractClass = retract===1?'text-indent':'';
    const lineHml = ('<p class="'+posClass+' '+boldClass+' '+retractClass+'">'+ extractVars(val)+'</p>');
    const txtHml = ('<p style="display: inline;vertical-align: middle;" class="'+posClass+' '+boldClass+' '+retractClass+'">'+ extractVars(val)+'</p>');

    let hml = addLine||monoLine?`<div class="cont" style="width: 100%;" id="anchor${id}">`:`<div class="cont" id="anchor${id}">`;
    hml=hml+`<span class="label">${name}</span>`+ (addLine?lineHml:txtHml)+ `</div>`;
    return hml;
  }

  //组合类型结构生成
  function combineStructure(data){
    const {name,questionMapping} = data;
    let hml='<div class="inner-table"><table>';
    const colNum = Math.ceil(questionMapping.length/2);
    let tdVal='';
    const regexp = /(【(.+?)】)/g;
    for(let i=0;i<questionMapping.length;){
      if(questionMapping[i+1]){
        tdVal="<td>"+questionMapping[i].name+extractVars(questionMapping[i].val)+"</td><td>"+questionMapping[i+1].name+extractVars(questionMapping[i+1].val)+"</td>";
      }else{
        tdVal="<td>"+questionMapping[i].name+extractVars(questionMapping[i].val)+"</td><td></td>";
      }
      if(i==0){
        hml=hml+`<tr><td rowspan="${colNum}">${name}</td>${tdVal}`;
      }else{
        hml=hml+`<tr>${tdVal}`;
      }
      hml=hml+"</tr>";
      i=((i+2)>questionMapping.length?i+1:i+2)
    }
    hml=hml+"</table></div>";
    return hml;
  }

  //抽取变量
  function extractVars(org){
    const regexp = /(【(.+?)】)/g;
    const arr = org.split(regexp);
    //console.log(arr)
    let htl = '',val='';
    for(let i=0;i<arr.length;i++){
      val = arr[i].indexOf("【")!=-1?'':(arr[i-1]&&arr[i-1].indexOf("【")!=-1?"{{html "+arr[i]+"}}":arr[i]);
      htl=htl+val;
    }
    return htl;
  }
//获取所有模板
  function getAllModules(){
  const param={
    hospitalId:getUrlArgObject("hid"),
    modeId:''
  };
    post(api.getModuleById,param).then((res)=>{
      if(res.data.code==='0') {
        const data = res.data.data;
        global_modules=data;
        getRecordDetail();
      }
    });
  }

});

